'-----------------------------------------------------------------------------
'                               SMA_with_Max168.bas
'                                for ATMEGA88
'                    JP1 JP2 JP3   JP1 JP2 JP3
'         :  - SMA,  N=2                  0   0   0     1   0   0
'                  - SMA,  N=3                  0   0   1     1   0   1
'                  - SMA,  N=4                  0   1   0     1   1   0
'                  - SMA,  N=5                  0   1   1     1   1   1
'                                  :                 
'                     0 -  
'                               Nick Ostroukhov
'-----------------------------------------------------------------------------
'
$regfile = "m168def.dat"
$hwstack = 32                     ' default use 32 for the hardware stack
$swstack = 20                     ' default use 10 for the SW stack
$framesize = 40                   ' default use 40 for the frame space
$crystal = 8000000                ' used crystal frequency

Dim i              As Byte   '
Dim j              As Byte   '
Dim timerconst     As Byte   '
Dim ch             As Byte   '    8-  
Dim n              As Word   '    
Dim k              As Byte   '  
Dim m              As Byte   '
Dim W              As Word   '  
Dim MAX_L          As Word   '   
Dim MAX_R          As Word   '   
Dim MAX_L1         As Word   '
Dim MAX_R1         As Word   '
Dim MAX_L_OLD1     As Word   '
Dim MAX_R_OLD1     As Word   '
Dim temp           As Word   '
Dim DeltaDOWN      As Byte   ' - ,      50 
Dim Points_L(7)    As Single '      
Dim Points_R(7)    As Single '      
Dim SMA_L_OLD      As Single '   
Dim SMA_R_OLD      As Single '   
Dim Nsma           As Byte   ' -    SMA
Dim temp1          As Single '
Dim temp2          As Single '
Dim temp3          As Single '
Dim temp4          As Single '
Dim Greed          As Byte   ' , 0 -  , 1 - 
Dim ADMUX_L        As Byte   '     PC5
Dim ADMUX_R        As Byte   '     PC4
Dim ADC_LOW        As Byte   '      
Dim P(4)           As Byte   '   
Dim D1(4)          As Byte   '   8  
Dim D2(4)          As Byte   '  2   (.   6,7)

Config Timer0= TIMER, Prescale= 64        ' F.=125 

Config PORTD=Output      ' 1-5-    8,9,10 
Config PORTB=Output      '    6,7
Config PORTC.0=Input     ' 3     
Config PORTC.1=Input     '
Config PORTC.2=Input     '
'Config PORTC.3=Input     '  
Config PORTC.4=Input     '    
Config PORTC.5=Input     '    

ADMUX_L=&B11000100        ' PC4    
ADMUX_R=&B11000101        ' PC5    
ADMUX=ADMUX_L             '      
ADCSRB =&B00000000
DIDR0  =&B00110000        '     PC4  PC5
ADCSRA =&B10000110        ' . ,    64, 125 , 8 /
ADCSRA =&B11000110        '   
Waitus 500

P(1)=&B00000001           '    
P(2)=&B00000010           '   
P(3)=&B00000100           '    
P(4)=&B00001000           '   

MAX_L=0
MAX_R=0
MAX_L1=0
MAX_R1=0
DeltaDOWN=20
ch=2

W=0
n=0
k=0

For i=1 To 7
  Points_L(i)=0
  Points_R(i)=0
Next i
SMA_L_OLD=0
SMA_R_OLD=0

Timerconst=127             '    1 
Stop Timer0
Timer0=Timerconst
On Timer0 Change:

Greed=0                    ' 0 -  , 1 -  
Start Timer0
Enable Interrupts
Enable Timer0


L:                                 '  
NOP
NOP
NOP
GOTO L


Change:                            '  
  Stop Timer0
  Timer0 = Timerconst
  Start Timer0                     '  
  PORTB=0                          ' 
  k=k+1
  If k=5 Then k=1
  PORTD=D1(k)
  i=D2(k)
  PORTB=i OR P(k)                  '      

  ADC_LOW=ADCL                     '    
  W=ADCH                           '    
  Shift W, LEFT,8                 '    8 
  W=W+ADC_LOW                      '   

  If Greed=0 Then                 '    
     Greed=1
     If W>MAX_L Then MAX_L=W      ' ,   
     ADMUX=ADMUX_R                 '     ( PC4 )
             Else                  '    
     Greed=0
     IF W>MAX_R Then MAX_R=W      ' ,   
     ADMUX=ADMUX_L                 '     ( PC5 )
  End If
  ADCSRA =&B11000110               '  


  If n=50  Then                   '   50 
     m=PINC                       '    
     m=m AND &B00000111           '     PC2, PC1, PC0
     If ch<>m Then
       ch=m
       For i=1 To 7
          Points_L(i)=0
          Points_R(i)=0
          SMA_L_OLD=0
          SMA_R_OLD=0
       Next i
     End If
     Select Case ch
       Case   0:  NSMA=2          ' SMA   NSMA=2    
       Case   1:  NSMA=3          ' SMA   NSMA=3
       Case   2:  NSMA=4          ' SMA   NSMA=4
       Case   3:  NSMA=5          ' SMA   NSMA=5
       Case   4:  NSMA=2          ' SMA   NSMA=2    
       Case   5:  NSMA=3          ' SMA   NSMA=3
       Case   6:  NSMA=4          ' SMA   NSMA=4
       Case   7:  NSMA=5          ' SMA   NSMA=5
     End Select

     Gosub SMA
     Gosub Compare

     n=0
     MAX_L=0
     MAX_R=0
           Else
     n=n+1
  End If

Return



SMA:

       MAX_L1=MAX_L                           '   
       MAX_R1=MAX_R

       IF MAX_L1 >= MAX_L_OLD1 Then          '  
          MAX_L_OLD1=MAX_L1
                               Else          '  
          IF Max_L_OLD1 < DeltaDOWN Then     '   DeltaDOWN
             MAX_L_OLD1=MAX_L1
                                     Else    '    DeltaDOWN
             temp=MAX_L_OLD1-DeltaDOWN
             If MAX_L1 < temp Then           '    
               MAX_L1=temp
               MAX_L_OLD1=temp
                              Else
               MAX_L_OLD1=MAX_L1
             End If
          End If
       EndIF

       IF MAX_R1 >= MAX_R_OLD1 Then          '  
          MAX_R_OLD1=MAX_R1
                               Else          '  
          IF Max_R_OLD1 < DeltaDOWN Then    '   DeltaDOWN
             MAX_R_OLD1=MAX_R1
                                     Else    '    DeltaDOWN
             temp=MAX_R_OLD1-DeltaDOWN
             If MAX_R1 < temp Then           '    
               MAX_R1=temp
               MAX_R_OLD1=temp
                              Else
               MAX_R_OLD1=MAX_R1
             End If
          End If
       EndIF

       temp1=Points_L(1)            '    
       temp2=Points_R(1)            '
       j=Nsma-1
       For i=1 To j                '      1 .
         Points_L(i)=Points_L(i+1)
         Points_R(i)=Points_R(i+1)
       Next i
       temp3=MAX_L\Nsma             '    
       Points_L(Nsma)=temp3         '   
       temp4=MAX_R\Nsma             '
       Points_R(Nsma)=temp4         '
       temp3=temp3+SMA_L_OLD        '   ,   n
       temp4=temp4+SMA_R_OLD        '   ,   n
       If temp3 > temp1 Then
         temp3=temp3-temp1          '    
                        Else
         temp3=0
       End If
       If temp4 > temp2 Then
         temp4=temp4-temp2          '    
                        Else
         temp4=0
       End If
       SMA_L_OLD=temp3              '
       SMA_R_OLD=temp4              '

       MAX_L=Round(temp3)
       MAX_R=Round(temp4)

Return


Compare:

     i=1                                '     
     j=0                                ' 
     If MAX_L >   41  Then Set i.1     ' .  - 40                2
     If MAX_L >   63  Then Set i.2     '       - 36                  3
     If MAX_L >   90  Then Set i.3     '       - 32                  4
     If MAX_L >  125  Then Set i.4     '       - 28                  5
     If MAX_L >  169  Then Set j.6     '       - 24                  6
     If MAX_L >  195  Then Set j.7     '       - 22                  7
     If MAX_L >  224  Then Set i.5     '       - 20                  8
     If MAX_L >  256  Then Set i.6     '       - 18                  9
     If MAX_L >  293  Then Set i.7     '       - 16                 10
     D1(1)=i                            '     
     D2(1)=j                            '
                                        '
     i=0
     j=0
     If MAX_L >  334  Then Set i.0     '       - 14                  1
     If MAX_L >  380  Then Set i.1     '       - 12                  2
     If MAX_L >  432  Then Set i.2     '       - 10                  3
     If MAX_L >  490  Then Set i.3     '       -  8                  4
     If MAX_L >  555  Then Set i.4     '       -  6                  5
     If MAX_L >  628  Then Set j.6     '       -  4                  6
     If MAX_L >  709  Then Set j.7     '       -  2                  7
     If MAX_L >  801  Then Set i.5     '          0                  8
     If MAX_L >  904  Then Set i.6     '       +  2                  9
     If MAX_L > 1020  Then Set i.7     '       +  4                 10
     D1(2)=i                            '    
     D2(2)=j                            '

     i=1                                '     
     j=0                                ' 
     If MAX_R >   41  Then Set i.1     ' .  - 40                2
     If MAX_R >   63  Then Set i.2     '       - 36                  3
     If MAX_R >   90  Then Set i.3     '       - 32                  4
     If MAX_R >  125  Then Set i.4     '       - 28                  5
     If MAX_R >  169  Then Set j.6     '       - 24                  6
     If MAX_R >  195  Then Set j.7     '       - 22                  7
     If MAX_R >  224  Then Set i.5     '       - 20                  8
     If MAX_R >  256  Then Set i.6     '       - 18                  9
     If MAX_R >  293  Then Set i.7     '       - 16                 10
     D1(3)=i                            '     
     D2(3)=j                            '

     i=0
     j=0
     If MAX_R >  334  Then Set i.0     '       - 14                  1
     If MAX_R >  380  Then Set i.1     '       - 12                  2
     If MAX_R >  432  Then Set i.2     '       - 10                  3
     If MAX_R >  490  Then Set i.3     '       -  8                  4
     If MAX_R >  555  Then Set i.4     '       -  6                  5
     If MAX_R >  628  Then Set j.6     '       -  4                  6
     If MAX_R >  709  Then Set j.7     '       -  2                  7
     If MAX_R >  801  Then Set i.5     '          0                  8
     If MAX_R >  904  Then Set i.6     '       +  2                  9
     If MAX_R > 1020  Then Set i.7     '       +  4                 10
     D1(4)=i                            '    
     D2(4)=j                            '


     If ch>3 Then
       i=0
       j=0
       m=0
       Select Case MAX_L1
             Case Is >  1020: Set   i.7
             Case Is >   904: Set   i.6
             Case Is >   801: Set   i.5
             Case Is >   709: Set   j.7
             Case Is >   628: Set   j.6
             Case Is >   555: Set   i.4
             Case Is >   490: Set   i.3
             Case Is >   432: Set   i.2
             Case Is >   380: Set   i.1
             Case Is >   334: Set   i.0
             Case Else: m=1
       End Select
       D1(2)=D1(2) OR i                  '    
       D2(2)=D2(2) OR j

       i=0
       j=0
       If m=1 Then
         Select Case MAX_L1
             Case Is >   293: Set   i.7
             Case Is >   256: Set   i.6
             Case Is >   224: Set   i.5
             Case Is >   195: Set   j.7
             Case Is >   169: Set   j.6
             Case Is >   125: Set   i.4
             Case Is >    90: Set   i.3
             Case Is >    63: Set   i.2
             Case Is >    41: Set   i.1
         End Select
       End If
       D1(1)=D1(1) OR i                  '    
       D2(1)=D2(1) OR j

       i=0
       j=0
       m=0
       Select Case MAX_R1
             Case Is >  1020: Set   i.7
             Case Is >   904: Set   i.6
             Case Is >   801: Set   i.5
             Case Is >   709: Set   j.7
             Case Is >   628: Set   j.6
             Case Is >   555: Set   i.4
             Case Is >   490: Set   i.3
             Case Is >   432: Set   i.2
             Case Is >   380: Set   i.1
             Case Is >   334: Set   i.0
             Case Else: m=1
       End Select
       D1(4)=D1(4) OR i                  '    
       D2(4)=D2(4) OR j

       i=0
       j=0
       If m=1 Then
         Select Case MAX_R1
             Case Is >   293: Set   i.7
             Case Is >   256: Set   i.6
             Case Is >   224: Set   i.5
             Case Is >   195: Set   j.7
             Case Is >   169: Set   j.6
             Case Is >   125: Set   i.4
             Case Is >    90: Set   i.3
             Case Is >    63: Set   i.2
             Case Is >    41: Set   i.1
         End Select
       End If
       D1(3)=D1(3) OR i                  '    
       D2(3)=D2(3) OR j                        '
     End If

Return



End